From 80b791dbad018dbc957a785ec8ef923546955a6b Mon Sep 17 00:00:00 2001
From: Matthew Harmsen <mharmsen@redhat.com>
Date: Fri, 24 Apr 2015 11:51:00 -0600
Subject: [PATCH] Fixed minor UI inconsistencies.

---
 dogtag/common-ui/shared/kra/services.properties     | 2 +-
 dogtag/common-ui/shared/ocsp/404.properties         | 4 ++--
 dogtag/common-ui/shared/ocsp/agent/ports.properties | 2 +-
 dogtag/common-ui/shared/ocsp/services.properties    | 2 +-
 dogtag/common-ui/shared/tks/agent/ports.properties  | 2 +-
 dogtag/common-ui/shared/tks/services.properties     | 2 +-
 6 files changed, 7 insertions(+), 7 deletions(-)

diff --git a/dogtag/common-ui/shared/kra/services.properties b/dogtag/common-ui/shared/kra/services.properties
index e9a1b34..ea8f66d 100644
--- a/dogtag/common-ui/shared/kra/services.properties
+++ b/dogtag/common-ui/shared/kra/services.properties
@@ -1,2 +1,2 @@
 logo = <a href="http://pki.fedoraproject.org/" title="Visit pki.fedoraproject.org for more information about Dogtag products and services"><img src="/pki/images/logo_header.gif" alt="Dogtag" id="myLogo" /></a>
-title = <a href="/" title="Dogtag Network homepage">Dogtag<sup><font size="-2">&reg;</font></sup> Certificate System</a>
+title = <a href="/" title="Certificate System">Dogtag<sup><font size="-2">&reg;</font></sup> Certificate System</a>
diff --git a/dogtag/common-ui/shared/ocsp/404.properties b/dogtag/common-ui/shared/ocsp/404.properties
index 63d004e..e9a1b34 100644
--- a/dogtag/common-ui/shared/ocsp/404.properties
+++ b/dogtag/common-ui/shared/ocsp/404.properties
@@ -1,2 +1,2 @@
-logo = <img src="/pki/images/logo_header.gif">
-title = <font size="+1" face="PrimaSans BT, Verdana, sans-serif" color="white"><b>Dogtag<sup><font color="#cccccc" size="-2">&reg;</font></sup> Certificate Manager</b></font>
+logo = <a href="http://pki.fedoraproject.org/" title="Visit pki.fedoraproject.org for more information about Dogtag products and services"><img src="/pki/images/logo_header.gif" alt="Dogtag" id="myLogo" /></a>
+title = <a href="/" title="Dogtag Network homepage">Dogtag<sup><font size="-2">&reg;</font></sup> Certificate System</a>
diff --git a/dogtag/common-ui/shared/ocsp/agent/ports.properties b/dogtag/common-ui/shared/ocsp/agent/ports.properties
index 42dc1ff..ca891f9 100644
--- a/dogtag/common-ui/shared/ocsp/agent/ports.properties
+++ b/dogtag/common-ui/shared/ocsp/agent/ports.properties
@@ -1,2 +1,2 @@
 logo = <img src="/pki/images/logo_header.gif">
-title = <a href="/" title="Dogtag Network homepage">Dogtag<sup><font size="-2">&reg;</font></sup> Certificate System</a>
+title = <font size="+1" face="PrimaSans BT, Verdana, sans-serif" color="white"><b>Dogtag<sup><font color="#999999" size="-2">&reg;</font></sup> Services Summary</b></font>
diff --git a/dogtag/common-ui/shared/ocsp/services.properties b/dogtag/common-ui/shared/ocsp/services.properties
index e9a1b34..ea8f66d 100644
--- a/dogtag/common-ui/shared/ocsp/services.properties
+++ b/dogtag/common-ui/shared/ocsp/services.properties
@@ -1,2 +1,2 @@
 logo = <a href="http://pki.fedoraproject.org/" title="Visit pki.fedoraproject.org for more information about Dogtag products and services"><img src="/pki/images/logo_header.gif" alt="Dogtag" id="myLogo" /></a>
-title = <a href="/" title="Dogtag Network homepage">Dogtag<sup><font size="-2">&reg;</font></sup> Certificate System</a>
+title = <a href="/" title="Certificate System">Dogtag<sup><font size="-2">&reg;</font></sup> Certificate System</a>
diff --git a/dogtag/common-ui/shared/tks/agent/ports.properties b/dogtag/common-ui/shared/tks/agent/ports.properties
index f359664..ca891f9 100644
--- a/dogtag/common-ui/shared/tks/agent/ports.properties
+++ b/dogtag/common-ui/shared/tks/agent/ports.properties
@@ -1,2 +1,2 @@
 logo = <img src="/pki/images/logo_header.gif">
-title = <font size="+1" face="PrimaSans BT, Verdana, sans-serif" color="white"><b>Dogtag<sup><font color="#999999" size="-2">&reg;</font></sup><b>Certificate System</b></font>
+title = <font size="+1" face="PrimaSans BT, Verdana, sans-serif" color="white"><b>Dogtag<sup><font color="#999999" size="-2">&reg;</font></sup> Services Summary</b></font>
diff --git a/dogtag/common-ui/shared/tks/services.properties b/dogtag/common-ui/shared/tks/services.properties
index e9a1b34..ea8f66d 100644
--- a/dogtag/common-ui/shared/tks/services.properties
+++ b/dogtag/common-ui/shared/tks/services.properties
@@ -1,2 +1,2 @@
 logo = <a href="http://pki.fedoraproject.org/" title="Visit pki.fedoraproject.org for more information about Dogtag products and services"><img src="/pki/images/logo_header.gif" alt="Dogtag" id="myLogo" /></a>
-title = <a href="/" title="Dogtag Network homepage">Dogtag<sup><font size="-2">&reg;</font></sup> Certificate System</a>
+title = <a href="/" title="Certificate System">Dogtag<sup><font size="-2">&reg;</font></sup> Certificate System</a>
-- 
1.8.3.1