>From 9b747e2bbd551dc04dbe8658631382c27b95abdd Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Fri, 24 Apr 2015 12:46:38 -0400
Subject: [PATCH] Fix some javadoc errors that prevent F23 build

---
 base/common/src/com/netscape/certsrv/apps/CMS.java                    | 4 ----
 base/common/src/com/netscape/certsrv/apps/ICMSEngine.java             | 4 ----
 base/common/src/com/netscape/certsrv/profile/IProfileInput.java       | 1 -
 base/common/src/com/netscape/certsrv/profile/IProfileOutput.java      | 1 -
 base/common/src/com/netscape/certsrv/profile/ProfileDataInfo.java     | 2 +-
 .../src/com/netscape/certsrv/profile/ProfileRetrievalRequest.java     | 2 +-
 base/common/src/com/netscape/certsrv/security/IEncryptionUnit.java    | 3 ---
 base/common/src/com/netscape/certsrv/security/ITransportKeyUnit.java  | 3 ---
 base/javadoc/CMakeLists.txt                                           | 1 +
 9 files changed, 3 insertions(+), 18 deletions(-)

diff --git a/base/common/src/com/netscape/certsrv/apps/CMS.java b/base/common/src/com/netscape/certsrv/apps/CMS.java
index 5ba6dc0a6b29a9f072f17a8e0d9cf5afa1ac8d69..e301e20ef033002ca0a1115529b6cedfee650f74 100644
--- a/base/common/src/com/netscape/certsrv/apps/CMS.java
+++ b/base/common/src/com/netscape/certsrv/apps/CMS.java
@@ -1115,7 +1115,6 @@ public final class CMS {
      * @param name configuration name
      * @param isValueConfigured true if value is configured
      * @param params configuration parameters
-     * @exception EBaseException failed to create subject alt name configuration
      */
     public static void getGeneralNameConfigDefaultParams(String name,
             boolean isValueConfigured, Vector<String> params) {
@@ -1129,7 +1128,6 @@ public final class CMS {
      * @param name configuration name
      * @param isValueConfigured true if value is configured
      * @param params configuration parameters
-     * @exception EBaseException failed to create subject alt name configuration
      */
     public static void getGeneralNamesConfigDefaultParams(String name,
             boolean isValueConfigured, Vector<String> params) {
@@ -1143,7 +1141,6 @@ public final class CMS {
      * @param name configuration name
      * @param isValueConfigured true if value is configured
      * @param info configuration parameters
-     * @exception EBaseException failed to create subject alt name configuration
      */
     public static void getGeneralNameConfigExtendedPluginInfo(String name,
             boolean isValueConfigured, Vector<String> info) {
@@ -1157,7 +1154,6 @@ public final class CMS {
      * @param name configuration name
      * @param isValueConfigured true if value is configured
      * @param info configuration parameters
-     * @exception EBaseException failed to create subject alt name configuration
      */
     public static void getGeneralNamesConfigExtendedPluginInfo(String name,
             boolean isValueConfigured, Vector<String> info) {
diff --git a/base/common/src/com/netscape/certsrv/apps/ICMSEngine.java b/base/common/src/com/netscape/certsrv/apps/ICMSEngine.java
index 294447d293c9c3c6ab0d78611d27cdca3e56e982..b90c739970e993d5d46ba10b16e1bafd8836ba0a 100644
--- a/base/common/src/com/netscape/certsrv/apps/ICMSEngine.java
+++ b/base/common/src/com/netscape/certsrv/apps/ICMSEngine.java
@@ -919,7 +919,6 @@ public interface ICMSEngine extends ISubsystem {
      * @param name configuration name
      * @param isValueConfigured true if value is configured
      * @param params configuration parameters
-     * @exception EBaseException failed to create subject alt name configuration
      */
     public void getGeneralNameConfigDefaultParams(String name,
             boolean isValueConfigured, Vector<String> params);
@@ -930,7 +929,6 @@ public interface ICMSEngine extends ISubsystem {
      * @param name configuration name
      * @param isValueConfigured true if value is configured
      * @param params configuration parameters
-     * @exception EBaseException failed to create subject alt name configuration
      */
     public void getGeneralNamesConfigDefaultParams(String name,
             boolean isValueConfigured, Vector<String> params);
@@ -941,7 +939,6 @@ public interface ICMSEngine extends ISubsystem {
      * @param name configuration name
      * @param isValueConfigured true if value is configured
      * @param info configuration parameters
-     * @exception EBaseException failed to create subject alt name configuration
      */
     public void getGeneralNameConfigExtendedPluginInfo(String name,
             boolean isValueConfigured, Vector<String> info);
@@ -952,7 +949,6 @@ public interface ICMSEngine extends ISubsystem {
      * @param name configuration name
      * @param isValueConfigured true if value is configured
      * @param info configuration parameters
-     * @exception EBaseException failed to create subject alt name configuration
      */
     public void getGeneralNamesConfigExtendedPluginInfo(String name,
             boolean isValueConfigured, Vector<String> info);
diff --git a/base/common/src/com/netscape/certsrv/profile/IProfileInput.java b/base/common/src/com/netscape/certsrv/profile/IProfileInput.java
index 09b42806d1341cd9dfe78bd55f6d7a71d7f3d4aa..d025e563b4602d65f012a4e9486aeb2ff28878b5 100644
--- a/base/common/src/com/netscape/certsrv/profile/IProfileInput.java
+++ b/base/common/src/com/netscape/certsrv/profile/IProfileInput.java
@@ -113,7 +113,6 @@ public interface IProfileInput extends IConfigTemplate {
      * @param locale user locale
      * @param request request
      * @param value value
-     * @exception EProfileException failed to get value
      */
     public void setValue(String name, Locale locale, IRequest request,
             String value) throws EPropertyException;
diff --git a/base/common/src/com/netscape/certsrv/profile/IProfileOutput.java b/base/common/src/com/netscape/certsrv/profile/IProfileOutput.java
index dd3b47c54ca78cf2bc80e0fe46da5499a5833967..5b5dfe8cd4dd84456267716bf0873929423e4445 100644
--- a/base/common/src/com/netscape/certsrv/profile/IProfileOutput.java
+++ b/base/common/src/com/netscape/certsrv/profile/IProfileOutput.java
@@ -114,7 +114,6 @@ public interface IProfileOutput extends IConfigTemplate {
      * @param locale user locale
      * @param request request
      * @param value property value
-     * @exception EProfileException failed to retrieve value
      */
     public void setValue(String name, Locale locale, IRequest request,
             String value) throws EPropertyException;
diff --git a/base/common/src/com/netscape/certsrv/profile/ProfileDataInfo.java b/base/common/src/com/netscape/certsrv/profile/ProfileDataInfo.java
index c01d55d16ac63d02cae45bbf76ddc4aefc21e75a..5c2fea5d38a73bf2332b3ed4aed18f7d383e0063 100644
--- a/base/common/src/com/netscape/certsrv/profile/ProfileDataInfo.java
+++ b/base/common/src/com/netscape/certsrv/profile/ProfileDataInfo.java
@@ -54,7 +54,7 @@ public class ProfileDataInfo {
     }
 
     /**
-     * @param keyURL the profileURL to set
+     * @param profileURL the profileURL to set
      */
     public void setProfileURL(String profileURL) {
         this.profileURL = profileURL;
diff --git a/base/common/src/com/netscape/certsrv/profile/ProfileRetrievalRequest.java b/base/common/src/com/netscape/certsrv/profile/ProfileRetrievalRequest.java
index 608686b7913247730daa4a79ea7161db82873109..a88748521f4692c403d1282d6fd58cddf6293842 100644
--- a/base/common/src/com/netscape/certsrv/profile/ProfileRetrievalRequest.java
+++ b/base/common/src/com/netscape/certsrv/profile/ProfileRetrievalRequest.java
@@ -58,7 +58,7 @@ public class ProfileRetrievalRequest {
     }
 
     /**
-     * @param ProfileId the ProfileId to set
+     * @param profileId the ProfileId to set
      */
     public void setProfileId(String profileId) {
         this.profileId = profileId;
diff --git a/base/common/src/com/netscape/certsrv/security/IEncryptionUnit.java b/base/common/src/com/netscape/certsrv/security/IEncryptionUnit.java
index 6e4b9252c43ffad23a38ad47809f2290a537e852..23a1f773f78884ff70a3c89adaa1e70428e43532 100644
--- a/base/common/src/com/netscape/certsrv/security/IEncryptionUnit.java
+++ b/base/common/src/com/netscape/certsrv/security/IEncryptionUnit.java
@@ -89,10 +89,8 @@ public interface IEncryptionUnit extends IToken {
      * Unwraps data. This method rebuilds the private key by
      * unwrapping the private key data.
      *
-     * @param sessionKey session key that unwrap the private key
      * @param symmAlgOID symmetric algorithm
      * @param symmAlgParams symmetric algorithm parameters
-     * @param privateKey private key data
      * @param pubKey public key
      * @param transportCert transport certificate
      * @return private key object
@@ -139,7 +137,6 @@ public interface IEncryptionUnit extends IToken {
      *
      * @param encSymmKey wrapped symmetric key to be unwrapped
      * @return Symmetric key object
-     * @exception EBaseException failed to unwrap
      */
 
     public SymmetricKey unwrap_sym(byte encSymmKey[],
diff --git a/base/common/src/com/netscape/certsrv/security/ITransportKeyUnit.java b/base/common/src/com/netscape/certsrv/security/ITransportKeyUnit.java
index 1208a7d420e3a40e52ab2cf9c2d1b3be369c05df..bc3d76a1ec714d0016adec8eb9ed09a86c0941b0 100644
--- a/base/common/src/com/netscape/certsrv/security/ITransportKeyUnit.java
+++ b/base/common/src/com/netscape/certsrv/security/ITransportKeyUnit.java
@@ -69,7 +69,6 @@ public interface ITransportKeyUnit extends IEncryptionUnit {
      * @param encSymmKey wrapped symmetric key to be unwrapped
      * @param usage Key usage for unwrapped key.
      * @return Symmetric key object
-     * @exception EBaseException failed to unwrap
      */
 
     public SymmetricKey unwrap_sym(byte encSymmKey[], SymmetricKey.Usage usage);
@@ -80,7 +79,6 @@ public interface ITransportKeyUnit extends IEncryptionUnit {
      *
      * @param encSymmKey wrapped symmetric key to be unwrapped
      * @return Symmetric key object
-     * @exception EBaseException failed to unwrap
      */
 
     public SymmetricKey unwrap_sym(byte encSymmKey[]);
@@ -91,7 +89,6 @@ public interface ITransportKeyUnit extends IEncryptionUnit {
      *
      * @param encSymmKey wrapped symmetric key to be unwrapped
      * @return Symmetric key object
-     * @exception EBaseException failed to unwrap
      */
 
     public SymmetricKey unwrap_encrypt_sym(byte encSymmKey[]);
diff --git a/base/javadoc/CMakeLists.txt b/base/javadoc/CMakeLists.txt
index 8e892ee866f8faa3832bf12150f0fa8eef8693f5..47d18399aac7ada6ef92b1e8957759af28ced658 100644
--- a/base/javadoc/CMakeLists.txt
+++ b/base/javadoc/CMakeLists.txt
@@ -24,6 +24,7 @@ javadoc(pki-javadoc
         ${HTTPCLIENT_JAR} ${HTTPCORE_JAR}
         ${JAXRS_API_JAR} ${RESTEASY_JAXRS_JAR} ${RESTEASY_ATOM_PROVIDER_JAR} ${RESTEASY_CLIENT_JAR}
         ${PKI_CMSUTIL_JAR} ${PKI_CERTSRV_JAR} ${PKI_TOMCAT_JAR} ${PKI_CMS_JAR} ${PKI_TOOLS_JAR}
+        ${NUXWDOG_JAR}
     OPTIONS
         -windowtitle 'pki-javadoc'
         -doctitle '<h1>PKI Javadoc</h1>'
-- 
1.9.3